﻿Public Class EliminarAviso
    Dim objeto As String
    Dim tipo As String
    Dim Nlogin As String
    Dim OU As String
    Dim salida As String = "-------Eliminando-------"

    Friend Sub loadObject(ByVal Elem As String, ByVal tipoobj As String, ByVal LogU As String, ByVal ActualOU As String)
        '==========================================================================
        ' Name:     LoadObject
        ' Purpose:  Obtener el nombre del objeto que se quiere elliminar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        objeto = Elem
        tipo = tipoobj
        Nlogin = LogU
        OU = ActualOU
    End Sub

    Private Sub CancelButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        Me.Close()

    End Sub

    Private Sub AcceptButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     CancelButton_Click
        ' Purpose:  Cerrar la ventana sin reliazar ningún cambio
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        salida = salida & vbCrLf & "Eliminar: " & Nlogin & " tipo: " & tipo
        salida = salida & vbCrLf & "Eliminar..."
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Abrir el formulario dependiendo del elemento seleccionado en el combobox
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Try
            If tipo = "PERSON" Then
                If Not UserClass.GetUserProperty(Nlogin, "homeMDB") = "" Then
                    MailClass.DeleteMailbox(Nlogin)
                    'salida = salida & vbCrLf & "Tiene buzón y se elimina "
                End If
            End If
            Try
                GenericClass.RemoveFromOU(Nlogin, OU)
            Catch ex As Exception When Nlogin = ""
                MsgBox("Error al eliminar un objeto del directorio activo, el objeto no puede ser vacío " & ex.Message)
                salida = salida & vbCrLf & "Error: al eliminar un objeto del directorio activo, el objeto no puede ser vacío " & ex.Message
            Catch ex As Exception When OU = ""
                MsgBox("Error al eliminar un objeto del directorio activo, la dirección del objeto no puede ser vacía " & ex.Message)
                salida = salida & vbCrLf & "Error: aal eliminar un objeto del directorio activo, la dirección del objeto no puede ser vacía " & ex.Message
            Catch ex As Exception
                MsgBox("Error al eliminar un objeto del directorio activo " & ex.Message)
                salida = salida & vbCrLf & "Error: al eliminar un objeto del directorio activo " & ex.Message
            End Try


            salida = salida & vbCrLf & "Se ha eliminado"

            'Log
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)

            Me.Close()
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub EliminarAviso_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Label2.Text = objeto & " ?"
    End Sub
End Class