﻿Public Class EncriptClass
    Shared Function Encripta(ByVal pass As String) As String
        '==========================================================================
        ' Name:     Encripta
        ' Purpose:  Encripta el string del parámetro 'pass'
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   1 string: el string encriptado
        ' Calls:    Right de Strings
        '==========================================================================
        Dim Clave As String, i As Integer, Pass2 As String
        Dim CAR As String, Codigo As String
        'Clave de encriptado
        Clave = "%ü&/@#$A%"
        Pass2 = ""
        'Encriptado
        For i = 1 To Len(pass)
            CAR = Mid(pass, i, 1)
            Codigo = Mid(Clave, ((i - 1) Mod Len(Clave)) + 1, 1)
            Pass2 = Pass2 & Strings.Right("0" & Hex(Asc(Codigo) Xor Asc(CAR)), 2)
        Next i
        Encripta = Pass2
    End Function

    Shared Function DesEncripta(ByVal pass As String) As String
        '==========================================================================
        ' Name:     DesEncripta
        ' Purpose:  Desencripta el string del parámetro 'pass'
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   1 string: el string desencriptado
        ' Calls:    Right de Strings
        '==========================================================================
        Dim Clave As String, i As Integer, Pass2 As String
        Dim CAR As String, Codigo As String
        Dim j As Integer
        'Clave de encriptado
        Clave = "%ü&/@#$A%"
        Pass2 = ""
        j = 1
        'DesEncriptado
        For i = 1 To Len(pass) Step 2
            CAR = Mid(pass, i, 2)
            Codigo = Mid(Clave, ((j - 1) Mod Len(Clave)) + 1, 1)
            Pass2 = Pass2 & Chr(Asc(Codigo) Xor Val("&h" + CAR))
            j = j + 1
        Next i
        DesEncripta = Pass2
    End Function
End Class
