﻿Imports System.Text.RegularExpressions

Public Class NuevoNombre
    Dim tipoObjeto As String
    Friend Sub loadtipo(ByVal tipo As String)
        '==========================================================================
        ' Name:     loadName
        ' Purpose:  Obtener el nombre del objeto a utilizar más adelante
        ' Input:    1 string: el nombre del objeto 'name'
        ' Return:   None
        ' Calls:    none
        '==========================================================================
        tipoObjeto = tipo
    End Sub
    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Devuelve el nombre a asignar al objeto
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        'Si el textbox no está vacío se devuleve
        If Not NombreTextBox.Text = "" Then
            Dim puede As Boolean = True
            If tipoObjeto = "GROUP" Then
                If Not checkRejexUName(NombreTextBox.Text) Then
                    puede = False
                    MsgBox("El nombre de grupo incluye caracteres no permitidos, no puede contener \/[]:;|=,+*?<>""")
                End If
            Else
                If Not checkRejexCName(NombreTextBox.Text) Then
                    puede = False
                    MsgBox("El nombre de equipo incluye caracteres no permitidos, solo puede contener letras, números y guiónes")
                End If
            End If
            If puede Then
                Arbol.loadNewName(NombreTextBox.Text)
                Me.Close()
            End If

        Else
            MsgBox("El nombre no puede ser un texto vacío")
        End If
    End Sub

    Private Function checkRejexUName(ByVal strFindin As String) As Boolean
        Dim myRegex As New Regex("^([^\\/\[\]:;\|=,\+\*\?<""])+$")
        If myRegex.IsMatch(strFindin) Then
            Return True
        Else
            Return False
        End If
    End Function

    Private Function checkRejexCName(ByVal strFindin As String) As Boolean
        Dim myRegex As New Regex("^([0-9a-zA-Z]|-)+$")
        If myRegex.IsMatch(strFindin) Then
            Return True
        Else
            Return False
        End If
    End Function
End Class