﻿Public Class OpcionesEnvio

    Dim Usuario As String
    Dim NuevoUsu As String
    Dim primero As Boolean
    Dim forwarding As Boolean = False
    Dim recipients As Boolean = False
    Dim UsersToRemove As Boolean = False
    Dim removeUsers() As String
    Dim UserP As Boolean = False
    Dim lNewList As New List(Of String)

    Friend Sub LoadUser(ByVal User As String)
        '==========================================================================
        ' Name:     LoadUser
        ' Purpose:  Establecer el usuario del que se van a manipular los datos
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        Usuario = User
    End Sub
    Friend Sub LoadU(ByVal User As String)
        '==========================================================================
        ' Name:     LoadUser
        ' Purpose:  Establecer el usuario que se va a añadir para conceder permiso de enviar como
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        NuevoUsu = User
    End Sub
    Dim UsuDN As String
    Dim HayError As Boolean = False

    Private Sub OpcionesEnvio_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '==========================================================================
        ' Name:     OpcionesEnvio_Load
        ' Purpose:  Carga de los datos del usuario en la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetUserPropertyObject, GetUserProperty, GetUserPropertyInteger de UserClass
        '==========================================================================
        Dim salida As String
        primero = True
        Try
            UsuDN = UserClass.GetUserProperty(Usuario, "distinguishedName")
        Catch ex As Exception
            MsgBox("Error al obtener la dirección del usuario " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener la dirección del usuario " & Usuario & ex.Message
            HayError = True
        End Try
        '----------------------------------------Carga usuarios con permiso de envío como usuario principal.--------
        'lista usuarios permitidos a enviar como
        UsersListView.ShowItemToolTips = True
        ' Establecer modo columnas
        UsersListView.View = View.Details
        ' Establecer cabecera de la columna
        UsersListView.Clear()
        UsersListView.Columns.Add("Name", 150)
        Dim TempNode As ListViewItem
        'Obtener los usuarios permitidos a enviar como
        Try
            If (Not UserClass.GetUserPropertyObject(Usuario, "publicDelegates") Is Nothing) Then
                'Si solo es uno
                If UserClass.isUserPropertyString(Usuario, "publicDelegates") Then
                    Dim parte As String = UserClass.GetUserProperty(Usuario, "publicDelegates") '.ToString.ToString.Split(",")
                    Dim nombre As String '= parte(0).Substring(3)
                    nombre = UserClass.GetUserlogonN(parte)
                    TempNode = New ListViewItem(nombre)
                    UsersListView.Items.Add(TempNode)

                Else
                    'Mas de un usuario lista de objetos
                    Dim authomails() As Object = UserClass.GetUserPropertyObject(Usuario, "publicDelegates")

                    For i = 0 To authomails.Length - 1
                        Dim parte() As String = authomails(i).ToString.Split(",")
                        Dim nombre As String '= parte(0).Substring(3)
                        'TempNode = New ListViewItem(nombre)
                        nombre = UserClass.GetUserlogonN(authomails(i).ToString)
                        TempNode = New ListViewItem(nombre)
                        UsersListView.Items.Add(TempNode)
                    Next

                End If
            End If
        Catch ex As Exception
            'HayError = True
            MsgBox("Error al obtener usuarios con permisos de envío como el usuario " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener usuarios con permisos de envío como el usuario " & Usuario & ex.Message
            HayError = True
        End Try
        '--------------------------------------------Redirección--------------------------------------
        'Obtener el usuario al que hay que redirigir el correo, si es que lo hay
        Try
            If Not UserClass.GetUserProperty(Usuario, "altRecipient") = "" Then
                ForwardToRadioButton.Checked = True
                NoneRadioButton.Checked = False
                'Hay que redirigir el correo a un usuario
                Dim parte As String = UserClass.GetUserProperty(Usuario, "altRecipient").ToString '.Split(",")
                Dim nombre As String = GenericClass.GetlogonN(parte) 'parte(0).Substring(3)
                ForwardToTextBox.Text = nombre
                DeliverbothCheckBox.Enabled = True
                DeliverbothCheckBox.Checked = UserClass.GetUserProperty(Usuario, "DeliverAndRedirect")
            Else
                'No hay que redirigir el correo a nadie
                ForwardToTextBox.Text = ""
                NoneRadioButton.Checked = True
                ForwardToRadioButton.Checked = False
                DeliverbothCheckBox.Enabled = False
            End If
        Catch ex As Exception
            'HayError = True
            MsgBox("Error al obtener el usuario al que hay que redirigir el correo del usuario " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el usuario al que hay que redirigir el correo del usuario " & Usuario & ex.Message
            HayError = True
        End Try

        Try
            If Not UserClass.GetUserProperty(Usuario, "DeliverAndRedirect") = "" Then
                DeliverbothCheckBox.Checked = UserClass.GetUserProperty(Usuario, "DeliverAndRedirect")
            End If
        Catch ex As Exception
            MsgBox("Error al obtener el dato que establece si el se redirige el correo al dueño también " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el dato que establece si el se redirige el correo al dueño también " & Usuario & ex.Message
            HayError = True
        End Try

        '---------------------------------------------Límite Destinatarios-----------------------------
        'Obtener límite de destinatarios
        Try
            If Not UserClass.GetUserPropertyInteger(Usuario, "msExchRecipLimit") = 0 Then
                'No utiliza los destinatarios por defecto
                DefaultRecipientsRadioButton.Checked = False
                MaxRecipientsTextBox.Text = UserClass.GetUserPropertyInteger(Usuario, "msExchRecipLimit")
            Else
                'Establece el número de destinatarios por defecto
                DefaultRecipientsRadioButton.Checked = True
                MaxRecipientsTextBox.Text = ""
                MaxRecipientsTextBox.Enabled = False
            End If
        Catch ex As Exception
            MsgBox("Error al obtener el dato que establece el límite de destinatarios del correo del usuario " & ex.Message)
            salida = salida & vbCrLf & "Error al obtener el dato que establece el límite de destinatarios del correo del usuario " & Usuario & ex.Message
            HayError = True
        End Try

        If HayError Then
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
        End If

        '---------------------------------------------------------------------------------------------------
        primero = False
        AcceptButton.Enabled = False

    End Sub

    '----------------------------------------------------------------------------------------------------------
    '----------------------------------Control de los cambios en los campos mediante excepciones----------------

    Private Sub DefaultRecipientsRadioButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DefaultRecipientsRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     DefaultRecipientsRadioButton_Click
        ' Purpose:  Deshabilitar el textbox y habilitar los botones aceptar y cancelar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If DefaultRecipientsRadioButton.Checked Then
            If Not primero Then
                MaxRecipientsTextBox.Text = ""
                MaxRecipientsTextBox.Enabled = False
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
                MaxRecipientsTextBox.Enabled = False
                recipients = True
            End If
        End If

    End Sub

    Private Sub MaxRecipientsTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles MaxRecipientsTextBox.KeyPress
        '==========================================================================
        ' Name:     MaxRecipientsTextBox_KeyPress
        ' Purpose:  Controlar que no solo se pueda insertar caracteres en el textbox
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If Not (Char.IsNumber(e.KeyChar) Or Char.IsControl(e.KeyChar)) Then e.Handled = True
    End Sub

    Private Sub MaxRecipientsTextBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MaxRecipientsTextBox.TextChanged
        '==========================================================================
        ' Name:     MaxRecipientsTextBox_TextChanged
        ' Purpose:  Marcar que se ha cambiado el texto y habilitar los botones aceptar y cancelar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not primero Then
            AcceptButton.Enabled = True
            cancelButton.Enabled = True
            recipients = True
        End If

    End Sub

    Private Sub MaxRecipientsRadioButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MaxRecipientsRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     MaxRecipientsRadioButton_Click
        ' Purpose:  Marcar que se ha cambiado el checkbox y habilitar los botones aceptar y cancelar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If MaxRecipientsRadioButton.Checked Then
            If Not primero Then
                MaxRecipientsTextBox.Enabled = True
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
            End If
        End If

    End Sub

    Private Sub NoneRadioButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NoneRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     NoneRadioButton_Click
        ' Purpose:  Marcar que se ha cambiado el radiobutton y habilitar los botones aceptar y cancelar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If NoneRadioButton.Checked Then
            If Not primero Then
                ForwardToTextBox.Text = ""
                ModifyButton.Enabled = False
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
                DeliverbothCheckBox.Enabled = False
                forwarding = True
            End If
        End If

    End Sub

    Private Sub ForwardToRadioButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ForwardToRadioButton.CheckedChanged
        '==========================================================================
        ' Name:     ForwardToRadioButton_Click
        ' Purpose:  Marcar que se ha cambiado el radiobutton y habilitar el textbox y los botones aceptar y cancelar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        If ForwardToRadioButton.Checked Then
            If Not primero Then
                ModifyButton.Enabled = True
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
                DeliverbothCheckBox.Enabled = True
                forwarding = True
            End If
        End If

    End Sub

    Private Sub DeliverbothCheckBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DeliverbothCheckBox.CheckedChanged
        '==========================================================================
        ' Name:     ForwardToRadioButton_Click
        ' Purpose:  Marcar que se ha cambiado el checkbox y habilitar los botones aceptar y cancelar
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not primero Then
            AcceptButton.Enabled = True
            cancelButton.Enabled = True
            forwarding = True
        End If

    End Sub

    Private Sub AddButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddButton.Click
        '==========================================================================
        ' Name:     AddButton_Click
        ' Purpose:  Añadir nuevo usuario a los del listview de permitidos a enviar como
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        UserP = True
        'Llamar a la ventana de petición del usuario
        Añadir.Solo("userExch")
        Añadir.ShowDialog()

        If NuevoUsu = "" Then
            MsgBox("No se ha elegido ningún usuario")

        Else
            Dim puede As Boolean = True
            For i = 0 To UsersListView.Items.Count - 1
                If UsersListView.Items(i).Text = NuevoUsu Then
                    puede = False
                End If
            Next
            If puede Then
                'Actualizar el listview
                Dim nuevo As ListViewItem
                nuevo = New ListViewItem(NuevoUsu)
                UsersListView.Items.Add(nuevo)
                'Habilitar los botones aceptar y cancelar
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
            Else
                MsgBox("No se pueden repetir usuarios en la lista")
            End If
        End If

    End Sub

    Private Sub RemoveButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RemoveButton.Click
        '==========================================================================
        ' Name:     RemoveButton_Click
        ' Purpose:  Eliminar un usuario de los del listview de permitidos a enviar como
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not UsersListView.SelectedItems.Count = 0 Then
            UserP = True

            Dim seleccionados As ListView.SelectedListViewItemCollection = Me.UsersListView.SelectedItems
            Dim item As ListViewItem
            Dim i As Integer = 0
            Dim UsuAEliminar(seleccionados.Count - 1) As String
            'Eliminar el usuario del listview y obtener su índice
            For Each item In seleccionados
                UsuAEliminar(i) = item.Text
                lNewList.Add(item.Text)
                i = i + 1
                item.Remove()
            Next

            'Añadir el usuario al array de los usuarios a eliminar, teniéndo en cuenta que puede que el array no esté vacío
            If UsersToRemove Then
                For j = 0 To UsuAEliminar.Count - 1
                    lNewList.Add(UsuAEliminar(j))
                Next
            Else
                lNewList.AddRange(UsuAEliminar)
            End If

            'Habilitar botones de aceptar y cancelar
            If Not primero Then
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
            End If

            UsersToRemove = True
        Else
            MsgBox("selecciona algún usuario")
        End If

    End Sub

    Private Sub ModifyButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ModifyButton.Click
        '==========================================================================
        ' Name:     ModifyButton_Click
        ' Purpose:  Cambiar el usuario a redireccionar el correo
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        If Not primero Then

            'llamar a la ventana de introducir el usuario
            Añadir.Solo("userExch")
            Añadir.ShowDialog()
            If NuevoUsu = "" Then
                MsgBox("No se ha seleccionado ningún usuario")
            Else
                forwarding = True
                Dim UDN = UserClass.GetUserProperty(NuevoUsu, "distinguishedName")
                Dim DN() As String = UDN.Split(",")
                'Insertar en el textbox el nuevo usuario por el antiguo
                ForwardToTextBox.Text = NuevoUsu 'DN(0).Substring(3)
                'Habilitar los botones aceptar y cancelar
                AcceptButton.Enabled = True
                cancelButton.Enabled = True
            End If

        End If
 
    End Sub


    '------------------------------------------------------------------------------------------------
    '-----------------------------------Aceptar y cancelar-------------------------------------------------

    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Establecer los cambios efectuados en la ventana
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    GetUserProperty, SetUserPropertyBoolR, GetUserPropertyGN de UserClass
        '           SetForwardingAddress, SetReceptientLimits, GrantSendAs, DenySendAs de MailClass
        '==========================================================================
        Try
            Me.Cursor = Cursors.WaitCursor
            HayError = False
            Dim salida As String = "-------Opciones de Envio-------" & vbCrLf & "Dentro de Propiedades Usuario"
            salida = salida & vbCrLf & "Dueño del buzón:" & Usuario
            '---------------------------------Redireccionamiento------------------------------------------
            If forwarding Then
                'Establecer los cambios que producen los checkbox de la redirección
                If NoneRadioButton.Checked = True Then
                    salida = salida & vbCrLf & "Eliminar redirección de correo"
                    Try
                        MailClass.SetForwardingAddress(UsuDN, "")
                        ForwardToTextBox.Text = ""
                    Catch ex As Exception
                        MsgBox("Error al modificar redireccion de mensajes : " & ex.Message)
                        salida = salida & vbCrLf & "Error: al modificar redireccion de mensajes : " & ex.Message
                        HayError = True
                    End Try
                Else
                    If ForwardToTextBox.Text = "" Then

                        MsgBox("No hay ningún usuario seleccionado al que redireccionar el correo")
                        HayError = True
                    Else
                        salida = salida & vbCrLf & "Asignar dirección a la que redireccionar el correo:" & UserClass.GetUserProperty(ForwardToTextBox.Text, "distinguishedName")

                        Dim DN As String = UserClass.GetUserDN(ForwardToTextBox.Text)

                        Try
                            MailClass.SetForwardingAddress(UsuDN, DN) 'UserClass.GetUserProperty(ForwardToTextBox.Text, "distinguishedName"))
                        Catch ex As Exception
                            MsgBox("Error al modificar redireccion de mensajes : " & ex.Message)
                            salida = salida & vbCrLf & "Error: al modificar redireccion de mensajes : " & ex.Message
                            HayError = True
                        End Try
                    End If

                End If
                If DeliverbothCheckBox.Checked Then
                    salida = salida & vbCrLf & "Mensajes redireccionados los recibe el usuario también"
                    Try
                        UserClass.SetUserPropertyBoolR(Usuario, "DeliverAndRedirect", True)
                    Catch ex As Exception
                        MsgBox("Error al establecer que los mensajes redireccionados los reciba el usuario también " & ex.Message)
                        salida = salida & vbCrLf & "Error: al establecer que los mensajes redireccionados los reciba el usuario también " & ex.Message
                        HayError = True
                    End Try
                Else
                    salida = salida & vbCrLf & "Mensajes redireccionados no los recibe el usuario"
                    Try
                        UserClass.SetUserPropertyBoolR(Usuario, "DeliverAndRedirect", False)
                    Catch ex As Exception
                        MsgBox("Error al establecer que los mensajes redireccionados no los reciba el usuario también " & ex.Message)
                        salida = salida & vbCrLf & "Error: al establecer que los mensajes redireccionados no los reciba el usuario también " & ex.Message
                        HayError = True
                    End Try
                End If

            End If
            '-----------------------------------Límites de destinatarios-----------------------------------
            If recipients Then
                'Establecer los cambios de límite de destinatarios
                If DefaultRecipientsRadioButton.Checked Then
                    salida = salida & vbCrLf & "Número máximo de destinatarios por defecto"
                    Try
                        MailClass.SetReceptientLimits(UsuDN, -1)
                    Catch ex As Exception
                        MsgBox("Error al establecer el numero de destinatarios como número de destinatarios por defecto: " & ex.Message)
                        salida = salida & vbCrLf & "Error: al establecer el numero de destinatarios como número de destinatarios por defecto: " & ex.Message
                        HayError = True
                    End Try
                Else
                    salida = salida & vbCrLf & "Número máximo de destinatarios del mensaje:" & MaxRecipientsTextBox.Text
                    If MaxRecipientsTextBox.Text = "" Then
                        MsgBox("Njo se ha establecido el número de destinatarios")
                        HayError = True
                    Else
                        Try
                            MailClass.SetReceptientLimits(UsuDN, MaxRecipientsTextBox.Text)
                        Catch ex As Exception
                            MsgBox("Error al modificar el numero de destinatarios del mensaje : " & ex.Message)
                            salida = salida & vbCrLf & "Error: al modificar el numero de destinatarios del mensaje : " & ex.Message
                            HayError = True
                        End Try
                    End If

                End If

            End If
            '------------------------------------Enviar como-----------------------------------------------
            If UserP Then
                UserClass.ClearUserProperty(Usuario, "publicDelegates")
                For i = 0 To UsersListView.Items.Count - 1
                    salida = salida & vbCrLf & "Actualizar lista de usuarios con usuario:" & UsersListView.Items(i).Text
                    Try
                        'MsgBox(UsersListView.Items(i).Text)
                        UserClass.SetUserPropertyInsert(Usuario, "publicDelegates", UserClass.GetUserPropertyRefresh(UsersListView.Items(i).Text, "distinguishedName"), i)
                    Catch ex As Exception When UsersListView.Items(i).Text = ""
                        MsgBox("Error al añadir el usuario al grupo de los que es posible enviar como ellos(suplantarlos), el destinatario a añadir no puede ser vacio " & ex.Message)
                        salida = salida & vbCrLf & "Error: al añadir el usuario al grupo de los que es posible enviar como ellos(suplantarlos), el destinatario a añadir no puede ser vacio " & ex.Message
                        HayError = True
                    Catch ex As Exception
                        MsgBox("Error al añadir el usuario al grupo de los que es posible enviar como ellos(suplantarlos) " & ex.Message)
                        salida = salida & vbCrLf & "Error: al añadir el usuario al grupo de los que es posible enviar como ellos(suplantarlos) " & ex.Message
                        HayError = True
                    End Try
                Next
            End If


            'Cerrar ventana
            'Log
            Me.Cursor = Cursors.Default
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
            If Not HayError Then
                Me.Close()
            End If
        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub

    Private Sub cancelButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cancelButton.Click
        '==========================================================================
        ' Name:     cancelButton_Click
        ' Purpose:  Cerrar la ventana sin efectuar cambios
        ' Input:    1 Evento: 'e', 
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================

        Me.Close()

    End Sub

End Class