﻿Imports System
Imports System.IO
Imports System.Windows.Forms

Public Class RenombrarPerfil

    Private Sub RenameButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RenameButton.Click
        Try
            Dim salida As String = "-------Renombrar Perfíl-------"
            If PCTextBox.Text = "" Or OldProfileTextBox.Text = "" Or NewProfileTextBox.Text = "" Then
                MsgBox("Se deben rellenar todos los campos")
            Else
                PCTextBox.Text.Replace(" ", "")
                Me.Cursor = Cursors.WaitCursor
                If WMIClass.isProfile(PCTextBox.Text, OldProfileTextBox.Text) Then
                    salida = salida & vbCrLf & "Nombre del equipo al que pertenece el perfíl: " & PCTextBox.Text
                    salida = salida & vbCrLf & "Nombre del antiguo perfíl: " & OldProfileTextBox.Text
                    salida = salida & vbCrLf & "Nombre del nuevo perfíl: " & NewProfileTextBox.Text
                    salida = salida & vbCrLf & "Renombrando perfíl..."
                    Dim path As String
                    'Se crea la dirección donde buscar
                    Dim puede As Boolean = True
                    Dim p As Path
                    For Each ch As Char In p.GetInvalidFileNameChars
                        If NewProfileTextBox.Text.Contains(ch) Then
                            puede = False
                            Exit For
                        End If
                    Next
                    If Not puede Then
                        Me.Cursor = Cursors.Default
                        MsgBox("Se ha introducido un carácter no válido en el nombre de la carpeta")
                    Else
                        If Not WMIClass.isProfile(PCTextBox.Text, NewProfileTextBox.Text) Then
                            Try
                                WMIClass.renameProfile(PCTextBox.Text, OldProfileTextBox.Text, NewProfileTextBox.Text)
                            Catch ex As Exception When PCTextBox.Text = ""
                                MsgBox("Error al renombrar el perfíl, el nombre del equipo no puede ser vacío " & ex.Message)
                                salida = salida & vbCrLf & "Error: al renombrar el perfíl, el nombre del equipo no puede ser vacío " & ex.Message
                            Catch ex As Exception When OldProfileTextBox.Text = ""
                                MsgBox("Error al renombrar el perfíl, el nombre del perfíl a renombrar no puede ser vacío " & ex.Message)
                                salida = salida & vbCrLf & "Error: al renombrar el perfíl, el nombre del perfíl a renombrar no puede ser vacío " & ex.Message
                            Catch ex As Exception When NewProfileTextBox.Text = ""
                                MsgBox("Error al renombrar el perfíl, el nuevo nombre del perfíl no puede ser vacío " & ex.Message)
                                salida = salida & vbCrLf & "Error: al renombrar el perfíl, el nuevo nombre del perfíl no puede ser vacío " & ex.Message
                            Catch ex As Exception
                                MsgBox("Error al renombrar el perfíl " & ex.Message)
                                salida = salida & vbCrLf & "Error: al renombrar el perfíl " & ex.Message
                            End Try
                            salida = salida & vbCrLf & "Perfíl ha cambiado de nombre"
                            'Log
                            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", salida, False)
                            Me.Cursor = Cursors.Default
                            Me.Close()
                        Else
                            MsgBox("Ya existe un perfíl con el nuevo nombre")
                        End If
                    End If

                    Me.Cursor = Cursors.Default
                Else
                    MsgBox("No se puede acceder al perfil, comprueba el nombre actual del perfíl o el del equipo")
                End If

            End If

        Catch ex As Exception
            GenericClass.Log(My.Application.Info.DirectoryPath & "\Log", String.Format("Error  – ‘{0}’", ex.Message), False)
            End
        End Try
    End Sub
End Class