﻿Imports System.IO

Public Class NombreNuevaCarpeta

    Private Sub AcceptButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AcceptButton.Click
        '==========================================================================
        ' Name:     AcceptButton_Click
        ' Purpose:  Devuelve el nombre de la carpeta
        ' Input:    1 Evento: 'e',
        '           1 Objeto: 'sender'
        ' Return:   None
        ' Calls:    None
        '==========================================================================
        'Si el textbox no está vacío se devuleve
        If Not NombreTextBox.Text = "" Then
            Dim puede As Boolean = True
            Dim p As Path
            For Each ch As Char In p.GetInvalidFileNameChars
                If NombreTextBox.Text.Contains(ch) Then
                    puede = False
                    Exit For
                End If
            Next
            If puede Then
                recursosCompartidosArbol.loadName(NombreTextBox.Text)
                Me.Close()
            Else
                MsgBox("La carpeta incluye símbolos no permitidos")
            End If
        Else
            MsgBox("El nombre no puede ser un texto vacío")
        End If
    End Sub
End Class